package fr.vertx;

import org.vertx.java.core.Handler;
import org.vertx.java.core.Vertx;
import org.vertx.java.core.VertxFactory;
import org.vertx.java.core.http.ServerWebSocket;

import java.io.IOException;

public class Ack {
    public static void main(String[] args) throws IOException {
        final Vertx vertx = VertxFactory.newVertx();

        vertx.createHttpServer().websocketHandler(new Handler<ServerWebSocket>() {
            @Override
            public void handle(final ServerWebSocket serverWebSocket) {
                System.out.println("new websocket on " + serverWebSocket.path() + " with headers " + serverWebSocket.headers());

                if ("/delay".equals(serverWebSocket.path())) {
                    // the ack is sent with a delay after the connection opening
                    Long delayTime = 2000L; // delay of 2 seconds by default
                    if (serverWebSocket.headers().contains("time"))
                        delayTime = Long.valueOf(serverWebSocket.headers().get("time"));
                    vertx.setTimer(delayTime, new Handler<Long>() {
                        @Override
                        public void handle(Long aLong) {
                            serverWebSocket.writeTextFrame("ack");
                        }
                    });
                } else {
                    // the ack is sent directly
                    serverWebSocket.writeTextFrame("ack");
                }
            }
        }).listen(9090);

        System.out.println("server started at ws://localhost:9090");
        System.in.read();
    }
}
